<template>
    <a-modal :open="modal.open" :title="modal.title" :width="640" :confirm-loading="modal.confirmLoading"
        :after-close="onAfterClose" :cancel-text="cancelText" :ok-text="okText" @ok="handleOk" @cancel="handleCancel">
        <a-spin :spinning="spining">
            <a-form ref="formRef" :model="formData" :rules="formRules">
                <a-card class="mb-8-2">
                    <a-row :gutter="12">
                        <a-col :span="24">
                            <a-form-item :label="'父级分类'" name="parentID">
                                <a-tree-select v-model:value="formData.parentID" show-search style="width: 100%"
                                    :dropdown-style="{ maxHeight: '400px', overflow: 'auto' }" placeholder="请选择"
                                    allow-clear tree-default-expand-all :tree-data="treeData"
                                    tree-node-filter-prop="label">
                                </a-tree-select>
                            </a-form-item>
                        </a-col>
                        <a-col :span="24">
                            <a-form-item :label="'产品分类'" name="label">
                                <a-input :placeholder="'请输入产品分类名称'" v-model:value="formData.label"></a-input>
                            </a-form-item>
                        </a-col>
                     
                    </a-row>
                </a-card>
            </a-form>
        </a-spin>

    </a-modal>
</template>

<script setup>
import { cloneDeep } from 'lodash-es'
import { ref, onBeforeMount } from 'vue'
import { config } from '@/config'
import apis from '@/apis'
import { useForm, useModal, useSpining } from '@/hooks'
import { message } from 'ant-design-vue'
import { useI18n } from 'vue-i18n'

import { spliceUrl } from '@/utils/util'
const areaFormRef = ref()
const emit = defineEmits(['ok'])
const { t } = useI18n() // 解构出t方法
const { modal, showModal, hideModal, showLoading, hideLoading } = useModal()
const { formRecord, formData, formRef, formRules, resetForm } = useForm()
const { spining, showSpining, hideSpining } = useSpining()
const cancelText = ref(t('button.cancel'))
const okText = ref(t('button.confirm'))
const treeData=ref([])
formRules.value = {
    label: { required: true, message: '请输入产品类别名称' },
}


const initData = async () => {
    const { success, data, total } = await apis.categorys
        .getDataList({
            pageSize:99,
            page: 1,
        })
        .catch(() => {
            throw new Error()
        })
    if (config('http.code.success') === success) {
        treeData.value = data.map(item => ({
            ...item
        }))
    }
}
/**
 * 新建
 */
function handleCreate() {
    showModal({
        type: 'create',
        title: '产品分类',
    })
    // 初始化所有字段
    initData()
}


/**
 * 确定
 */
function handleOk() {
    formRef.value.validateFields().then(async (values) => {
        try {
            showLoading()
            const params = {
                ...values,
                parentID:formData.value.parentID?formData.value.parentID:0
            }
            let result = null
            switch (modal.value.type) {
                case 'create':
                    result = await apis.categorys.createProductsItem(params).catch((error) => {
                        throw new Error(error)
                    })
                    break
                case 'edit':
                    result = await apis.products.updateProductsItem(formData.value.id, params).catch(() => {
                        throw new Error(error)
                    })
                    break
            }
            hideLoading()
            if (config('http.code.success') === result?.success) {
                hideModal()
                emit('ok')
            }
        } catch (error) {
            message.error({ content: error.message })
            hideLoading()
        }
    })
        .catch((e) => {
            console.log(e)
            hideLoading()
        })
}


/**
 * 取消
 */
function handleCancel() {
    hideModal()
}

/**
 * 关闭后
 */
function onAfterClose() {
    resetForm()
    hideLoading()
}

defineExpose({
    handleCreate,
})


</script>

<style lang="less" scoped></style>
